##############################################################################
# $Id: xdtv-fedora.spec.in,v 1.13 2007/02/01 22:26:31 aballier Exp $
##############################################################################

%define _unpackaged_files_terminate_build 0

%define with_tvfonts	 	1
%define with_optimization 	0
%define with_debug 		0
%define with_xinerama 		1
%define with_ogg 		1
%define with_xvid 		1
%define with_external_ffmpeg 	0
%define with_ffmpeg 		1
%define with_ffmpeg_amrnb	0
%define with_ffmpeg_amrnb_fixed	0
%define with_ffmpeg_amrwb	0
%define with_lame 		1
%define with_faac 		1
%define with_x264 		1
%define with_dvb 		1
%define with_zvbi 		1
%define with_lirc 		1
%define with_alsa 		1
%define with_png 		1
%define with_jpeg 		1

# Without
%{?_without_tvfonts: 		%{expand: %%global with_tvfonts 0}}
%{?_without_optimization: 	%{expand: %%global with_optimization 0}}
%{?_without_debug: 		%{expand: %%global with_debug 0}}
%{?_without_xinerama: 		%{expand: %%global with_xinerama 0}}
%{?_without_ogg: 		%{expand: %%global with_ogg 0}}
%{?_without_xvid: 		%{expand: %%global with_xvid 0}}
%{?_without_external_ffmpeg: 	%{expand: %%global with_external_ffmpeg 0}}
%{?_without_ffmpeg: 		%{expand: %%global with_ffmpeg 0}}
%{?_without_ffmpeg_amrnb:	%{expand: %%global with_ffmpeg_amrnb 0}}
%{?_without_ffmpeg_amrnb_fixed:	%{expand: %%global with_ffmpeg_amrnb_fixed 0}}
%{?_without_ffmpeg_amrwb:	%{expand: %%global with_ffmpeg_amrwb 0}}
%{?_without_lame: 		%{expand: %%global with_lame 0}}
%{?_without_faac: 		%{expand: %%global with_faac 0}}
%{?_without_x264: 		%{expand: %%global with_x264 0}}
%{?_without_dvb: 		%{expand: %%global with_dvb 0}}
%{?_without_zvbi: 		%{expand: %%global with_zvbi 0}}
%{?_without_lirc: 		%{expand: %%global with_lirc 0}}
%{?_without_alsa: 		%{expand: %%global with_alsa 0}}
%{?_without_png: 		%{expand: %%global with_png 0}}
%{?_without_jpeg: 		%{expand: %%global with_jpeg 0}}

# With
%{?_with_tvfonts: 		%{expand: %%global with_tvfonts 1}}
%{?_with_optimization: 		%{expand: %%global with_optimization 1}}
%{?_with_debug: 		%{expand: %%global with_debug 1}}
%{?_with_xinerama: 		%{expand: %%global with_xinerama 1}}
%{?_with_ogg: 			%{expand: %%global with_ogg 1}}
%{?_with_xvid: 			%{expand: %%global with_xvid 1}}
%{?_with_external_ffmpeg: 	%{expand: %%global with_external_ffmpeg 1}}
%{?_with_ffmpeg: 		%{expand: %%global with_ffmpeg 1}}
%{?_with_ffmpeg_amrnb: 		%{expand: %%global with_ffmpeg_amrnb 1}}
%{?_with_ffmpeg_amrnb_fixed: 	%{expand: %%global with_ffmpeg_amrnb_fixed 1}}
%{?_with_ffmpeg_amrwb: 		%{expand: %%global with_ffmpeg_amrwb 1}}
%{?_with_lame: 			%{expand: %%global with_lame 1}}
%{?_with_faac: 			%{expand: %%global with_faac 1}}
%{?_with_x264: 			%{expand: %%global with_x264 1}}
%{?_with_dvb: 			%{expand: %%global with_dvb 1}}
%{?_with_zvbi: 			%{expand: %%global with_zvbi 1}}
%{?_with_lirc: 			%{expand: %%global with_lirc 1}}
%{?_with_alsa: 			%{expand: %%global with_alsa 1}}
%{?_with_png: 			%{expand: %%global with_png 1}}
%{?_with_jpeg: 			%{expand: %%global with_jpeg 1}}

%define fontdir			%{_datadir}/X11/fonts/misc/

Name:           xdtv
Version:        2.4.0
Release:        1.fc6
Summary:        %{Name} is a software to watch, record & stream TV.

Group:          Applications/Multimedia
License:        GPL
Distribution:   Fedora Core
Packager:       Pingus <pingus_77@yahoo.fr>
URL:            http://xawdecode.sourceforge.net/
Source0:        http://prdownloads.sourceforge.net/xawdecode/xdtv-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  libX11-devel
BuildRequires:  libXext-devel
BuildRequires:  libXmu-devel
BuildRequires:  libXt-devel
BuildRequires:  libXv-devel
BuildRequires:  libXxf86dga-devel
BuildRequires:  libXxf86vm-devel
BuildRequires:  libXpm-devel
BuildRequires:  libXaw-devel
BuildRequires:  desktop-file-utils
%if %with_external_ffmpeg
BuildRequires:  ffmpeg-devel
%endif
%if %with_tvfonts
BuildRequires:  xorg-x11-font-utils
BuildRequires:  xorg-x11-server-utils
%endif
%if %with_xinerama
BuildRequires:  libXinerama-devel
%endif
%if %with_xvid
BuildRequires:  xvidcore-devel
%endif
%if %with_faac
BuildRequires:  faac-devel
%endif
%if %with_x264
BuildRequires:  x264-devel
%endif
%if %with_lame
BuildRequires:  lame-devel
%endif
%if %with_zvbi
BuildRequires:  zvbi-devel
%endif
%if %with_lirc
BuildRequires:  lirc-devel
%endif
%if %with_jpeg
BuildRequires:  libjpeg-devel
%endif
%if %with_png
BuildRequires:  libpng-devel
%endif
%if %with_ogg
BuildRequires:  libtheora-devel >= 1.0alpha5
BuildRequires:  libvorbis-devel >= 1.1.0
BuildRequires:  libogg-devel >= 1.1.2
%endif
%if %with_alsa
BuildRequires:  alsa-lib-devel
%endif
BuildRequires:  neXtaw-devel
BuildRequires:  gcc-c++
%if %with_dvb
BuildRequires:  SDL-devel
BuildRequires:  curl-devel
%endif

Requires:       libX11
Requires:       libXext
Requires:       libXmu
Requires:       libXt
Requires:       libXv
Requires:       libXxf86dga
Requires:       libXxf86vm
Requires:       libXpm
Requires:	libXaw
%if %with_external_ffmpeg
Requires:       ffmpeg
Requires:       ffmpeg-libpostproc
%endif
%if %with_tvfonts
Requires:       xorg-x11-font-utils
Requires:       chkfontpath
%else
Requires:       tv-fonts
%endif
%if %with_xinerama
Requires:       libXinerama
%endif
%if %with_xvid
Requires:       xvidcore
%endif
%if %with_faac
Requires:       faac
%endif
%if %with_x264
Requires:       x264
%endif
%if %with_lame
Requires:       lame
%endif
%if %with_zvbi
Requires:       zvbi
%endif
%if %with_lirc
Requires:       lirc
%endif
%if %with_jpeg
Requires:       libjpeg
%endif
%if %with_png
Requires:       libpng
%endif
%if %with_ogg
Requires:       libtheora >= 1.0alpha5
Requires:       libvorbis >= 1.1.0
Requires:       libogg >= 1.1.2
%endif
%if %with_alsa
Requires:       alsa-lib
Requires:       alsa-utils
%endif
Requires:       xterm
Requires:       neXtaw
%if %with_dvb
Requires:       SDL
Requires:       curl
%endif

%description
%{Name} is a software to watch, record & stream TV.
It interacts with AleVT (Teletext) and Nxtvepg (NextView)
& supports the bttv, bktr & dvb APIs. It contains some
deinterlacing filters & record video files with various
containers (AVI, MPEG, OGG, etc.) & many codecs:
FFMpeg >=0.4.6, XviD 0.9 & 1.x, DivX 4 & 5, Ogg Vorbis
& Theora >=1.0a5. It has some plugin capabilities.

# -----------------------------------------------------------------------------

%package        devel
Summary:        Developpement files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    devel
Developpement files for %{name}

# -----------------------------------------------------------------------------

%if %with_tvfonts
%package        OSD-fonts
Summary:        TV Fonts used by the %{name} OSD function
Group:          User Interface/X
Requires:       %{name} = %{version}-%{release}
Obsoletes: 	xdtv-OSD-font

%description    OSD-fonts
TV Fonts used by the %{name} OSD function.
%endif

# -----------------------------------------------------------------------------

%prep
%setup -q

# -----------------------------------------------------------------------------

%build
%if %with_tvfonts
[ -n "$DISPLAY" ] && unset DISPLAY
%endif
./configure --prefix=%{_prefix} --mandir=%{_mandir} --libdir=%{_libdir} \
	--disable-divx4linux --with-gnu-ld \
%if %with_tvfonts
	--with-fontdir=%{fontdir} --enable-makefonts \
%else
	--disable-makefonts \
%endif
%if %with_optimization
	--enable-cpu-detection \
%else
	--disable-cpu-detection \
%endif
%if %with_debug
	--disable-nodebug \
%else
	--enable-nodebug \
%endif
%if %with_xinerama
	--enable-xinerama \
%else
	--disable-xinerama \
%endif
%if %with_ogg
	--enable-ogg \
%else
	--disable-ogg \
%endif
%if %with_xvid
	--enable-xvid \
%else
	--disable-xvid \
%endif
%if %with_external_ffmpeg
	--with-external-ffmpeg \
%endif
%if %with_ffmpeg
	--enable-ffmpeg \
%else
	--disable-ffmpeg \
%endif
%if %with_ffmpeg_amrnb
	--enable-ffmpeg-amrnb \
%else
	--disable-ffmpeg-amrnb \
%endif
%if %with_ffmpeg_amrnb_fixed
	--enable-ffmpeg-amrnb-fixed \
%else
	--disable-ffmpeg-amrnb-fixed \
%endif
%if %with_ffmpeg_amrwb
	--enable-ffmpeg-amrwb \
%else
	--disable-ffmpeg-amrwb \
%endif
%if %with_lame
	--enable-lame \
%else
	--disable-lame \
%endif
%if %with_faac
	--enable-faac \
%else
	--disable-faac \
%endif
%if %with_x264
	--enable-x264 \
%else
	--disable-x264 \
%endif
%if %with_zvbi
	--enable-zvbi \
%else
	--disable-zvbi \
%endif
%if %with_lirc
	--enable-lirc \
%else
	--disable-lirc \
%endif
%if %with_dvb
	--enable-dvb \
%else
	--disable-dvb \
%endif
%if %with_alsa
	--enable-alsa \
%else
	--disable-alsa \
%endif
%if %with_jpeg
	--enable-jpeg \
%else
	--disable-jpeg \
%endif
%if %with_png
	--enable-png \
%else
	--disable-png \
%endif

make prefix=%{_prefix}

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}
make prefix=%{_prefix} DESTDIR="$RPM_BUILD_ROOT" install

# Strip binaries (except the shell scripts)
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_v4l-conf
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_wizard
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_cmd
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_scantv
strip $RPM_BUILD_ROOT/%{_bindir}/%{name}_alevt*

# Bzip the man pages
bzip2 $RPM_BUILD_ROOT/%{_mandir}/man1/*.1

# Install the menu icon
install -D -m 644 xdtv-48.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/xdtv.png

# -----------------------------------------------------------------------------

# Create some desktop files for the XDG menu entries
%{__cat} <<EOF >xdtv.desktop
[Desktop Entry]
Name=XdTV
Comment=%{Summary}
Exec=xdtv
Icon=xdtv.png
Terminal=false
Type=Application
Categories=AudioVideo;
EOF

%{__cat} <<EOF >xdtv_wizard.desktop
[Desktop Entry]
Name=XdTV Wizard
Comment=%{Summary}
Exec=xdtv_wizard
Icon=xdtv.png
Terminal=false
Type=Application
Categories=AudioVideo;
EOF


# Install the XDG menu
install -D -m 644 xdtv.desktop $RPM_BUILD_ROOT%{_datadir}/applications/xdtv.desktop
install -D -m 644 xdtv_wizard.desktop $RPM_BUILD_ROOT%{_datadir}/applications/xdtv_wizard.desktop

desktop-file-install --vendor "" \
    --add-category X-Fedora \
    --dir $RPM_BUILD_ROOT%{_datadir}/applications \
    $RPM_BUILD_ROOT%{_datadir}/applications/*

# -----------------------------------------------------------------------------

# Cleanups
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
find $RPM_BUILD_ROOT -type f -name "*.la" -exec rm -f {} ';'

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%post
/sbin/ldconfig
/usr/bin/update-desktop-database -q
/sbin/install-info %{_infodir}/%{name}.info %{_infodir}/dir 2>/dev/null || :

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --delete %{_infodir}/%{name}.info %{_infodir}/dir 2>/dev/null || :
fi

%postun
/sbin/ldconfig
/usr/bin/update-desktop-database -q

# -----------------------------------------------------------------------------

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING INSTALL TODO ChangeLog lisez-moi
%doc README* lircrc* xdtvrc.sample FAQfr-xdtv
%{_bindir}/*
%{_mandir}/man1/*
%{_datadir}/X11/app-defaults/XdTV
%{_sysconfdir}/%{name}/*
%{_datadir}/pixmaps/*
%{_datadir}/%{name}/icons/*
%{_datadir}/applications/%{name}*

%files devel
%defattr(-,root,root,-)
%{_includedir}/*

# -----------------------------------------------------------------------------

%if %with_tvfonts
%post OSD-fonts
{
    umask 133
    %{_bindir}/mkfontdir %{fontdir}
    /usr/sbin/chkfontpath -q -a %{fontdir}:unscaled
} &> /dev/null || :

%postun OSD-fonts
{
    if [ "$1" = "0" ]; then
        /usr/sbin/chkfontpath -q -r %{fontdir}:unscaled
    fi
} &> /dev/null || :

%files OSD-fonts
%defattr(-,root,root,-)
%{fontdir}/*.pcf.gz
%endif

# -----------------------------------------------------------------------------

%changelog
* Sun Jan 28 2007 Sir Pingus <pingus_77@yahoo.fr> 2.4.0-1fc6
- Fix some small bugs in that spec files

* Fri Dec 22 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.4-1fc6
- Add a new switch: -with (by default) / -without tvfonts
- Change the default misc fonts path by this one: /usr/share/X11/fonts/misc
- Fix buildrequires for Xorg
- Add some new BuildRequires & Requires for the Xorg misc fonts
- Possibility to use tv-fonts
- Add the XDG menu support (needed with Fedora Core 6).
- Rename the OSD-font package as there are more than one OSD font now.
- Cleanup the spec file.
- Add a new switch: -with / -without (by default) external_ffmpeg

* Sat Mar 25 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.2-1fc5
- 2.3.2 on FC5
- The system app-defaults/ directory for X resources is now /usr/share/X11/app-defaults/ 
  on Fedora Core 5 and for future Red Hat Enterprise Linux systems.
- FC5 has modular X. All the libraries that were in xorg-x11-devel now have their own packages 
  and you need to include the -devel packages for the libraries your project is actually using.
- all infos here: http://fedora.redhat.com/docs/release-notes/fc5/
- new paths for desktop icons & TV misc fonts & font utils

* Sun Mar 19 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.2-1fc4
- 2.3.2
- fix error with the instalation of the TV fonts (need chkfontpath).
- fix error with the path of the ressource file (not the same path than in a Mandriva distro).
- fix error with the menu update (the menu was not updated).
- fix error with the path of the man files (return back to the old method).

* Fri Feb 24 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.1-1fc4
- 2.3.1
- FFmpeg inside XdTV
- Add the possibility to compile with amr_nb & amr_wb

* Fri Dec 23 2005 Sir Pingus <pingus_77@yahoo.fr> - 2.3.0-1
- 2.3.0
- Compiled with --disable-divx4linux & neXtaw
- Spec file updated

* Sun Jul 03 2005 Sir Pingus <pingus_77@yahoo.fr> - 2.2.0-2
- add the xdtv_wizard menu entry

* Fri Jul 01 2005 Sir Pingus <pingus_77@yahoo.fr> - 2.2.0-1
- Upgrade to 2.2.0
- Compiled with --disable-divx4linux
- Spec file cleanup 

* Sun Apr 03 2005 Emmanuel Seyman <seyman@wanadoo.fr> - 2.1.1-1
- Upgrade to 2.1.1

* Sun Jan 02 2005 Emmanuel Seyman <seyman@wanadoo.fr> - 2.0.1-1
- Upgrade to 2.0.1
- Obsolete xawdecode
- Clean up installation instructions

* Fri Nov 28 2003 Emmanuel Seyman <seyman@wanadoo.fr> - 1.8.2-1
- Upgrade to 1.8.2

* Sat Oct 04 2003 Emmanuel Seyman <seyman@wanadoo.fr> - 1.8.1-1
- Upgrade to 1.8.1

* Tue Sep 02 2003 Emmanuel Seyman <seyman@wanadoo.fr> - 1.8.0-1
- Initial RPM release.
